// MIDI Humanizer GUI Prototype
// Jacob Peck
// Team La-a
// 20111009

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GUIProto {
  private static void createAndShowGUI() {
    // initialize the frame
    JFrame frame = new JFrame("MIDI Humanizer GUI Prototype");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.getContentPane().setLayout(new BoxLayout(frame.getContentPane(), BoxLayout.PAGE_AXIS));
    frame.setIconImage(new ImageIcon("icon_midi.gif").getImage()); // <-- replace with Jamie's icon
  
    // menu bar
    JMenuBar menubar = new JMenuBar();
    JMenu filemenu = new JMenu("File");
    JMenu helpmenu = new JMenu("Help");
    menubar.add(filemenu);
    menubar.add(helpmenu);
    // under "File"
    JMenuItem loadfileaction = new JMenuItem("Load MIDI File...");
    JMenuItem selectprofileaction = new JMenuItem("Select Profile...");
    JMenuItem previewaction = new JMenuItem("Preview Humanization");
    JMenuItem exitaction = new JMenuItem("Exit MIDI Humanizer");
    // under "Help"
    JMenuItem onlinehelpaction = new JMenuItem("Help...");
    JMenuItem aboutaction = new JMenuItem("About MIDI Humanizer...");
    // adding to the menubar
    filemenu.add(loadfileaction);
    filemenu.add(selectprofileaction);
    filemenu.add(previewaction);
    filemenu.add(exitaction);
    helpmenu.add(onlinehelpaction);
    helpmenu.add(aboutaction);
    
    // file selection panel
    JPanel filepanel = new JPanel();
    JLabel filetext = new JLabel("Selected file:");
    JLabel selectedfilelabel = new JLabel("<none>");
    JButton fileselectbutton = new JButton("Load...");
    filepanel.add(filetext);
    filepanel.add(selectedfilelabel);
    filepanel.add(fileselectbutton);
    
    // profile selection panel
    JPanel profilepanel = new JPanel();
    JLabel profiletext = new JLabel("Selected profile:");
    JLabel selectedprofilelabel = new JLabel("<none>");
    JButton profileselectbutton = new JButton("Select...");
    profilepanel.add(profiletext);
    profilepanel.add(selectedprofilelabel);
    profilepanel.add(profileselectbutton);
    
    // MIDI info panel
    JPanel midiinfopanel = new JPanel();
    midiinfopanel.setLayout(new BoxLayout(midiinfopanel, BoxLayout.PAGE_AXIS));
    JLabel informationtext = new JLabel("General MIDI info:");
    informationtext.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel lengthpanel = new JPanel();
    JLabel midilengthtext = new JLabel("MIDI Length (ms):");
    JLabel midilengthvalue = new JLabel("<undefined>");
    lengthpanel.add(midilengthtext);
    lengthpanel.add(midilengthvalue);
    JPanel channelpanel = new JPanel();
    JLabel midichanneltext = new JLabel("Number of Channels:");
    JLabel midichannelvalue = new JLabel("<undefined>");
    channelpanel.add(midichanneltext);
    channelpanel.add(midichannelvalue);
    midiinfopanel.add(informationtext);
    midiinfopanel.add(lengthpanel);
    midiinfopanel.add(channelpanel);
    // and so on... god, Swing is verbose.
    
    // action panel
    JPanel actionpanel = new JPanel();
    JButton previewbutton = new JButton("Preview");
    JProgressBar progressbar = new JProgressBar(0,100);
    progressbar.setValue(50); // demo
    progressbar.setString("Working...");
    progressbar.setStringPainted(true);
    JButton beginhumanizationbutton = new JButton("GO");
    actionpanel.add(previewbutton);
    actionpanel.add(progressbar);
    actionpanel.add(beginhumanizationbutton);
    
    // register listeners
    exitaction.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        System.exit(0);
      }
    });    
    // ...
    
    // add it all to the frame
    frame.setJMenuBar(menubar);
    frame.getContentPane().add(filepanel);
    frame.getContentPane().add(profilepanel);
    frame.getContentPane().add(midiinfopanel);
    frame.getContentPane().add(actionpanel);
    
    // display the frame
    frame.pack();
    frame.setVisible(true);
  }
  
  static public void main(String[] args) {
    javax.swing.SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        createAndShowGUI();
      }
    });
  }
}
